/* Usage: java dancebattle_test <n> <m> <seed> <output_file>
 * n is the number of dance moves.
 * m is the number of moves that have already been made.
 * seed is a 64-bit integer used to seed the random number generator.
 */
public class dancebattle_test {
  public static void main(String[] args) {
    int n = Integer.parseInt(args[0]);
    int m = Integer.parseInt(args[1]);
    int max_moves = n * (n + 1) / 2;
    if (n % 2 == 0) {
      max_moves -= n / 2 - 1;
    }
    if (n < 1 || m < 0 || m > max_moves) {
      System.exit(1);
    }
    long seed = Long.parseLong(args[2]);
    java.util.Random r = new java.util.Random(seed);
    boolean successful;
    do {
      successful = true;
      Position p = new Position(n);
      Spacer sp = new Spacer(args[3]);
      sp.print(n);
      sp.println();
      sp.print(m);
      sp.println();
      int last_move = r.nextInt(n);
      for (int i = 0; i < m; i++) {
        int a = last_move;
        if (p.stuck(a)) {
          successful = false;
          break;
        }
        int b;
        do {
          b = r.nextInt(n);
        } while (!p.take(a, b));
        sp.print(a);
        sp.printSpace();
        sp.print(b);
        sp.println();
        last_move = b;
      }
      sp.close((int)seed % 3);
    } while (!successful);
  }
  static class Position {
    Position(int n) {
      n_ = n;
      taken_ = new boolean[n][n];
    }
    boolean stuck(int a) {
      for (int b = 0; b < a; b++) {
        if (!taken_[b][a]) {
          return false;
        }
      }
      for (int b = a; b < n_; b++) {
        if (!taken_[a][b]) {
          return false;
        }
      }
      return true;
    }
    boolean take(int a, int b) {
      if (a > b) {
        int t = a;
        a = b;
        b = t;
      }
      if (taken_[a][b]) {
        return false;
      } else {
        taken_[a][b] = true;
        return true;
      }
    }
    int n_;
    boolean[][] taken_;
  }
}
